/****************************************************************************
** Form interface generated from reading ui file 'mainform.ui'
**
** Created by User Interface Compiler
**
** WARNING! All changes made in this file will be lost!
****************************************************************************/

#ifndef MAINFORM_H
#define MAINFORM_H

#include <qvariant.h>
#include <qmainwindow.h>

class QVBoxLayout;
class QHBoxLayout;
class QGridLayout;
class QSpacerItem;
class QAction;
class QActionGroup;
class QToolBar;
class QPopupMenu;
class QSplitter;
class KListView;
class QListViewItem;
class QWidgetStack;

class MainForm : public QMainWindow
{
    Q_OBJECT

public:
    MainForm( QWidget* parent = 0, const char* name = 0, WFlags fl = WType_TopLevel );
    ~MainForm();

    QSplitter* splitter;
    KListView* fileTree;
    QWidgetStack* widgetStack;
    QMenuBar *menubar;
    QPopupMenu *fileMenu;
    QPopupMenu *popupMenu;
    QPopupMenu *editMenu;
    QPopupMenu *findMenu;
    QPopupMenu *projectMenu;
    QPopupMenu *debugMenu;
    QPopupMenu *toolsMenu;
    QPopupMenu *helpMenu;
    QToolBar *toolBar;
    QAction* fileOpenAction;
    QAction* fileSaveAllAction;
    QAction* fileSaveProjectAsAction;
    QAction* filePrintAction;
    QAction* fileExitAction;
    QAction* editUndoAction;
    QAction* editRedoAction;
    QAction* editCutAction;
    QAction* editCopyAction;
    QAction* editPasteAction;
    QAction* findFindAction;
    QAction* helpContentsAction;
    QAction* helpIndexAction;
    QAction* helpAboutAction;
    QActionGroup* fileNewActionGroup;
    QAction* fileNewProjectAction;
    QAction* fileNewFolderAction;
    QAction* fileNewCHeaderAction;
    QAction* fileNewGNUAssemblyHeaderAction;
    QAction* fileNewA68kAssemblyHeaderAction;
    QAction* fileNewCSourceFileAction;
    QAction* fileNewGNUAssemblySourceFileAction;
    QAction* fileNewA68kAssemblySourceFileAction;
    QAction* fileNewQuillSourceFileAction;
    QAction* fileNewTextFileAction;
    QAction* filePreferencesAction;
    QAction* editClearAction;
    QAction* editSelectAllAction;
    QAction* editIncreaseIndentAction;
    QAction* editDecreaseIndentAction;
    QAction* findReplaceAction;
    QAction* findFunctionsAction;
    QAction* findOpenFileAtCursorAction;
    QAction* projectAddFilesAction;
    QAction* projectCompileAction;
    QAction* projectMakeAction;
    QAction* projectBuildAction;
    QAction* projectErrorsAndWarningsAction;
    QAction* projectProgramOutputAction;
    QAction* projectOptionsAction;
    QAction* debugRunAction;
    QAction* debugPauseAction;
    QAction* debugResetAction;
    QAction* toolsConfigureAction;
    QAction* helpSearchAction;
    QAction* helpNewsAction;
    QAction* helpDocumentationAction;
    QAction* findFindSymbolDeclarationAction;
    QActionGroup* fileOpenActionGroup;
    QAction* fileOpenActionHidden;
    QAction* fileRecent1Action;
    QAction* fileRecent2Action;
    QAction* fileRecent3Action;
    QAction* fileRecent4Action;
    QAction* filePrintQuicklyAction;
    QAction* projectStopCompilationAction;
    QAction* projectForceQuitAction;

    static void deleteErrorsForLVFile( QListViewItem * item );
    static void deleteErrorsForSrcFile( void * srcFile );
    static void createErrorCursorsForSourceFile( QListViewItem * item );
    static void deleteOverwrittenErrorsIn( void * srcFile );
    static QString SGetFileName( int mode, const QString & fileFilter, const QString & caption, QWidget * parent );
    static QStringList SGetFileName_Multiple( const QString & fileFilter, const QString & caption, QWidget * parent );
    void * createView( const QString & fileName, const QString & fileText, QListViewItem * category );
    virtual void adoptSourceFile( void * srcFile );
    virtual bool openProject( const QString & fileName );
    int fileSavePrompt( QListViewItem * fileItem );
    virtual void fileSave_fromto( const QString & lastProj, const QString & nextProj );
    virtual void findAndOpenFile( const QString & fileName, void * category );
    virtual void openHeader( const QString & fileName, bool systemHeader, unsigned lineno );
    virtual QString writeTempSourceFile( void * srcFile, bool inProject );
    virtual void compileSourceFile( void * srcFile );
    static QString tilibsErrorMessage( int err );
    virtual QString textForHeader( const QString & fileName );

public slots:
    virtual void errorListView_clicked( QListViewItem * item );
    virtual bool findSourceFile( bool & inProject, void * & srcFile, const QString & fileName );
    virtual void init();
    virtual void destroy();
    virtual void te_popup_aboutToShow();
    virtual void te_popup_activated( int index );
    virtual void accel_activated( int index );
    virtual void completionPopup_closed();
    virtual void fileTreeAccel_activated( int index );
    virtual void fileNewProject();
    virtual void fileOpen();
    virtual void fileRecent1();
    virtual void fileRecent2();
    virtual void fileRecent3();
    virtual void fileRecent4();
    virtual bool fileSave();
    virtual bool fileSaveAs();
    virtual void filePrint();
    virtual void filePrintQuickly();
    virtual void filePreferences();
    virtual void editUndo();
    virtual void editRedo();
    virtual void editClear();
    virtual void editCut();
    virtual void editCopy();
    virtual void editPaste();
    virtual void editSelectAll();
    virtual void editIncreaseIndent();
    virtual void editDecreaseIndent();
    virtual void findFind();
    virtual void findFind_next();
    virtual void findFind_highlight( const QString & unused_text, int matchingindex, int matchedlength );
    virtual void findFind_stop();
    virtual void findReplace();
    virtual void findReplace_next();
    virtual void findReplace_highlight( const QString & unused_text, int matchingindex, int matchedlength );
    virtual void findReplace_replace( const QString & text, int replacementIndex, int replacedLength, int matchedLength );
    virtual void findReplace_stop();
    virtual void findFunctions();
    virtual void findFunctions_functionListBox_highlighted( int index );
    virtual void findFunctions_functionListBox_selected( int index );
    virtual void findFunctions_prototypeButton_clicked();
    virtual void findFunctions_implementationButton_clicked();
    virtual void findFunctionsPopup_aboutToShow();
    virtual void findFunctionsPopup_aboutToHide();
    virtual void findFunctionsPopup_aboutToHide_async();
    virtual void findFunctionsPopup_activated( int id );
    virtual void findOpenFileAtCursor();
    virtual void findFindSymbolDeclaration();
    virtual void projectAddFiles();
    virtual void procio_processExited();
    virtual void procio_readReady();
    virtual void procio_readReady_recordOnly();
    virtual void projectCompile();
    virtual void projectMake();
    virtual void projectBuild();
    virtual void projectStopCompilation();
    virtual void projectForceQuit();
    virtual void projectErrorsAndWarnings( bool on );
    virtual void projectProgramOutput();
    virtual void projectOptions();
    virtual void debugRun();
    virtual void debugPause();
    virtual void debugReset();
    virtual void toolsConfigure();
    virtual void toolsMenu_highlighted( int id );
    virtual void toolsMenu_activated( int id );
    virtual void toolsMenu_aboutToHide();
    virtual void helpDocumentation();
    virtual void helpContents();
    virtual void helpIndex();
    virtual void helpSearch();
    virtual void helpNews();
    virtual void helpAbout();
    virtual void resizeEvent( QResizeEvent * event );
    virtual void timerEvent( QTimerEvent * event );
    virtual void fileTreeClicked( QListViewItem * item );
    virtual void fileNewFolder();
    virtual void fileTreeContextMenuRequested( QListViewItem * item, const QPoint & pos, int unused_col );
    virtual void fileNewCHeader();
    virtual void fileNewGNUAssemblyHeader();
    virtual void fileNewA68kAssemblyHeader();
    virtual void fileNewCSourceFile();
    virtual void fileNewGNUAssemblySourceFile();
    virtual void fileNewA68kAssemblySourceFile();
    virtual void fileNewQuillSourceFile();
    virtual void fileNewTextFile();
    virtual void statusBar_messageChanged( const QString & message );
    virtual void current_view_cursorPositionChanged();
    virtual void current_view_textChanged();
    virtual void current_view_undoChanged();
    virtual void current_view_selectionChanged();
    virtual void current_view_charactersInteractivelyInserted( int line, int col, const QString & characters );
    virtual void clipboard_dataChanged();
    virtual void fileTreeItemRenamed( QListViewItem * item, const QString & newName, int col );
    virtual void KDirWatch_dirty( const QString & fileName );

protected:
    virtual void closeEvent( QCloseEvent * e );

    QHBoxLayout* MainFormLayout;

protected slots:
    virtual void languageChange();

private:
    void clearProject();
    QString findFilter( unsigned short job );
    void updateRecent();
    void addRecent( const QString & fileName );
    QListViewItem * openFile( QListViewItem * category, QListViewItem * parent, const QString & fileCaption, const QString & fileName );
    static QListViewItem * createFolder( QListViewItem * parent, const QString & name );
    void fileOpen_addList( QListViewItem * category, void * fileListV, void * dir, const QString & open_file );
    int savePrompt( void );
    void removeTrailingSpacesFromView( void * view );
    void fileSave_save( QListViewItem * theItem );
    void fileSave_saveAs( QListViewItem * theItem );
    void fileSave_loadList( QListViewItem * category, void * fileListV, const QString & base_dir, void * dir_new, QString * open_file );
    void findReplace_next( bool firstTime );
    int projectAddFiles_oneFile( const QString & fileName );
    void startCompiling();
    void stopCompiling();
    void compileFile( void * srcFile, bool inProject, bool force );
    void compileProject( bool forceAll );
    void linkProject();
    void showStats();
    bool tiemuInstance( void *& instancep );
    void updateToolsMenu();
    void updateSizes();
    bool removeItem( QListViewItem * item );
    QStringList extractAllFileNames( void );
    void extractFileTreeInfo( QListViewItem * parent, QListViewItem * * p_category, QString * p_folderPath );
    void newFile( QListViewItem * parent, QString text, const QPixmap & pixmap );
    void newFile( QListViewItem * parent );
    QListViewItem * resolveParent( QListViewItem * category );
    void updateLeftStatusLabel();
    void updateRightStatusLabel();
    void current_view_newLineHook();
    QString pathInProject( QListViewItem * item );

};

#endif // MAINFORM_H
