/****************************************************************************
** Form implementation generated from reading ui file 'wordlist.ui'
**
** Created by User Interface Compiler
**
** WARNING! All changes made in this file will be lost!
****************************************************************************/

#include "wordlist.h"

#include <qvariant.h>
#include <qpushbutton.h>
#include <keditlistbox.h>
#include <qcheckbox.h>
#include <kpushbutton.h>
#include <qlayout.h>
#include <qtooltip.h>
#include <qwhatsthis.h>
#include <qimage.h>
#include <qpixmap.h>

#include "keditlistbox.h"
#include "klineedit.h"
#include "kpushbutton.h"
/*
 *  Constructs a WordList as a child of 'parent', with the
 *  name 'name' and widget flags set to 'f'.
 *
 *  The dialog will by default be modeless, unless you set 'modal' to
 *  TRUE to construct a modal dialog.
 */
WordList::WordList( QWidget* parent, const char* name, bool modal, WFlags fl )
    : QDialog( parent, name, modal, fl )
{
    if ( !name )
	setName( "WordList" );
    WordListLayout = new QVBoxLayout( this, 11, 6, "WordListLayout"); 

    wordList = new KEditListBox( this, "wordList" );
    wordList->setButtons( int( KEditListBox::Remove | KEditListBox::Add ) );
    WordListLayout->addWidget( wordList );

    layout48 = new QHBoxLayout( 0, 0, 6, "layout48"); 
    spacer48 = new QSpacerItem( 41, 20, QSizePolicy::Expanding, QSizePolicy::Minimum );
    layout48->addItem( spacer48 );

    caseSensitive = new QCheckBox( this, "caseSensitive" );
    layout48->addWidget( caseSensitive );
    WordListLayout->addLayout( layout48 );

    layout44 = new QHBoxLayout( 0, 0, 6, "layout44"); 

    colorButton = new KPushButton( this, "colorButton" );
    layout44->addWidget( colorButton );

    styleButton = new KPushButton( this, "styleButton" );
    layout44->addWidget( styleButton );
    WordListLayout->addLayout( layout44 );
    spacer18 = new QSpacerItem( 20, 3, QSizePolicy::Minimum, QSizePolicy::Preferred );
    WordListLayout->addItem( spacer18 );

    layout2 = new QHBoxLayout( 0, 0, 6, "layout2"); 

    okButton = new KPushButton( this, "okButton" );
    okButton->setProperty( "stdItem", 1 );
    layout2->addWidget( okButton );

    cancelButton = new KPushButton( this, "cancelButton" );
    cancelButton->setProperty( "stdItem", 2 );
    layout2->addWidget( cancelButton );
    WordListLayout->addLayout( layout2 );
    languageChange();
    resize( QSize(213, 346).expandedTo(minimumSizeHint()) );
    clearWState( WState_Polished );

    // signals and slots connections
    connect( okButton, SIGNAL( clicked() ), this, SLOT( accept() ) );
    connect( cancelButton, SIGNAL( clicked() ), this, SLOT( reject() ) );
}

/*
 *  Destroys the object and frees any allocated resources
 */
WordList::~WordList()
{
    // no need to delete child widgets, Qt does it all for us
}

/*
 *  Sets the strings of the subwidgets using the current
 *  language.
 */
void WordList::languageChange()
{
    setCaption( tr( "Edit Word List" ) );
    wordList->setTitle( QString::null );
    caseSensitive->setText( tr( "C&ase Sensitive" ) );
    caseSensitive->setAccel( QKeySequence( tr( "Alt+A" ) ) );
    colorButton->setText( tr( "Co&lor..." ) );
    colorButton->setAccel( QKeySequence( tr( "Alt+L" ) ) );
    styleButton->setText( tr( "&Style..." ) );
    styleButton->setAccel( QKeySequence( tr( "Alt+S" ) ) );
    okButton->setText( tr( "&OK" ) );
    okButton->setAccel( QKeySequence( tr( "Alt+O" ) ) );
    cancelButton->setText( tr( "&Cancel" ) );
    cancelButton->setAccel( QKeySequence( tr( "Alt+C" ) ) );
}

