/****************************************************************************
** Form implementation generated from reading ui file 'customstyle.ui'
**
** Created by User Interface Compiler
**
** WARNING! All changes made in this file will be lost!
****************************************************************************/

#include "customstyle.h"

#include <qvariant.h>
#include <qpushbutton.h>
#include <qlabel.h>
#include <klineedit.h>
#include <qcheckbox.h>
#include <kpushbutton.h>
#include <qlayout.h>
#include <qtooltip.h>
#include <qwhatsthis.h>
#include <qimage.h>
#include <qpixmap.h>

#include "klineedit.h"
#include "kpushbutton.h"
/*
 *  Constructs a CustomStyle as a child of 'parent', with the
 *  name 'name' and widget flags set to 'f'.
 *
 *  The dialog will by default be modeless, unless you set 'modal' to
 *  TRUE to construct a modal dialog.
 */
CustomStyle::CustomStyle( QWidget* parent, const char* name, bool modal, WFlags fl )
    : QDialog( parent, name, modal, fl )
{
    if ( !name )
	setName( "CustomStyle" );
    CustomStyleLayout = new QVBoxLayout( this, 11, 6, "CustomStyleLayout"); 

    layout46 = new QGridLayout( 0, 1, 1, 0, 6, "layout46"); 

    endingLabel = new QLabel( this, "endingLabel" );

    layout46->addWidget( endingLabel, 1, 0 );

    beginningLabel = new QLabel( this, "beginningLabel" );

    layout46->addWidget( beginningLabel, 0, 0 );

    beginning = new KLineEdit( this, "beginning" );

    layout46->addWidget( beginning, 0, 1 );

    ending = new KLineEdit( this, "ending" );

    layout46->addWidget( ending, 1, 1 );
    CustomStyleLayout->addLayout( layout46 );

    layout47 = new QHBoxLayout( 0, 0, 6, "layout47"); 

    ignoreEndingAfterLabel = new QLabel( this, "ignoreEndingAfterLabel" );
    layout47->addWidget( ignoreEndingAfterLabel );

    ignoreEndingAfter = new KLineEdit( this, "ignoreEndingAfter" );
    ignoreEndingAfter->setMaxLength( 1 );
    layout47->addWidget( ignoreEndingAfter );
    CustomStyleLayout->addLayout( layout47 );

    switchable = new QCheckBox( this, "switchable" );
    CustomStyleLayout->addWidget( switchable );

    lineStartOnly = new QCheckBox( this, "lineStartOnly" );
    CustomStyleLayout->addWidget( lineStartOnly );

    layout44 = new QHBoxLayout( 0, 0, 6, "layout44"); 

    colorButton = new KPushButton( this, "colorButton" );
    layout44->addWidget( colorButton );

    styleButton = new KPushButton( this, "styleButton" );
    layout44->addWidget( styleButton );
    CustomStyleLayout->addLayout( layout44 );
    spacer18 = new QSpacerItem( 20, 16, QSizePolicy::Minimum, QSizePolicy::Expanding );
    CustomStyleLayout->addItem( spacer18 );

    layout2 = new QHBoxLayout( 0, 0, 6, "layout2"); 

    okButton = new KPushButton( this, "okButton" );
    okButton->setProperty( "stdItem", 1 );
    layout2->addWidget( okButton );

    cancelButton = new KPushButton( this, "cancelButton" );
    cancelButton->setProperty( "stdItem", 2 );
    layout2->addWidget( cancelButton );
    CustomStyleLayout->addLayout( layout2 );
    languageChange();
    resize( QSize(200, 236).expandedTo(minimumSizeHint()) );
    clearWState( WState_Polished );

    // signals and slots connections
    connect( cancelButton, SIGNAL( clicked() ), this, SLOT( reject() ) );
    connect( okButton, SIGNAL( clicked() ), this, SLOT( accept() ) );

    // buddies
    endingLabel->setBuddy( ending );
    beginningLabel->setBuddy( beginning );
    ignoreEndingAfterLabel->setBuddy( ignoreEndingAfter );
}

/*
 *  Destroys the object and frees any allocated resources
 */
CustomStyle::~CustomStyle()
{
    // no need to delete child widgets, Qt does it all for us
}

/*
 *  Sets the strings of the subwidgets using the current
 *  language.
 */
void CustomStyle::languageChange()
{
    setCaption( tr( "Edit Custom Style" ) );
    endingLabel->setText( tr( "&Ending:" ) );
    beginningLabel->setText( tr( "&Beginning:" ) );
    ignoreEndingAfterLabel->setText( tr( "&Ignore Ending After:" ) );
    switchable->setText( tr( "S&witchable" ) );
    switchable->setAccel( QKeySequence( tr( "Alt+W" ) ) );
    lineStartOnly->setText( tr( "Only &at beginning of line" ) );
    lineStartOnly->setAccel( QKeySequence( tr( "Alt+A" ) ) );
    colorButton->setText( tr( "Co&lor..." ) );
    colorButton->setAccel( QKeySequence( tr( "Alt+L" ) ) );
    styleButton->setText( tr( "&Style..." ) );
    styleButton->setAccel( QKeySequence( tr( "Alt+S" ) ) );
    okButton->setText( tr( "&OK" ) );
    okButton->setAccel( QKeySequence( tr( "Alt+O" ) ) );
    cancelButton->setText( tr( "&Cancel" ) );
    cancelButton->setAccel( QKeySequence( tr( "Alt+C" ) ) );
}

