/****************************************************************************
** Form interface generated from reading ui file 'preferencesdlg.ui'
**
** Created by User Interface Compiler
**
** WARNING! All changes made in this file will be lost!
****************************************************************************/

#ifndef PREFERENCES_H
#define PREFERENCES_H

#include <qvariant.h>
#include <qdialog.h>

class QVBoxLayout;
class QHBoxLayout;
class QGridLayout;
class QSpacerItem;
class QTabWidget;
class QWidget;
class QCheckBox;
class QButtonGroup;
class QRadioButton;
class QLabel;
class KIntNumInput;
class KPushButton;
class KComboBox;
class KListView;
class QListViewItem;
class QGroupBox;
class KListBox;
class QListBoxItem;
class KTextEdit;
class KLineEdit;

class Preferences : public QDialog
{
    Q_OBJECT

public:
    Preferences( QWidget* parent = 0, const char* name = 0, bool modal = FALSE, WFlags fl = 0 );
    ~Preferences();

    QTabWidget* tabWidget;
    QWidget* Widget8;
    QCheckBox* stopAtFirstError;
    QCheckBox* jumpToError;
    QCheckBox* successMessage;
    QCheckBox* deleteAsmFiles;
    QCheckBox* deleteObjFiles;
    QCheckBox* splitSourceFiles;
    QCheckBox* allowImplicitDeclaration;
    QCheckBox* autoSave;
    QCheckBox* downloadHeadlines;
    QCheckBox* deleteOverwrittenErrors;
    QCheckBox* useSystemIcons;
    QWidget* Widget9;
    QButtonGroup* linkTarget;
    QRadioButton* targetNone;
    QRadioButton* targetTiEmu;
    QRadioButton* targetRealCalc;
    QButtonGroup* linkPort;
    QRadioButton* port1;
    QRadioButton* port2;
    QRadioButton* port3;
    QRadioButton* port4;
    QButtonGroup* linkCable;
    QRadioButton* grayLink;
    QRadioButton* blackLink;
    QRadioButton* parallelLink;
    QRadioButton* silverLink;
    QRadioButton* directLink;
    QWidget* TabPage;
    QLabel* tabWidthCLabel;
    KIntNumInput* tabWidthC;
    QLabel* tabWidthAsmLabel;
    KIntNumInput* tabWidthAsm;
    QCheckBox* useBgColor;
    QLabel* bgColor;
    KPushButton* bgColorChange;
    QLabel* editorFontLabel;
    QLabel* editorFont;
    KPushButton* editorFontChange;
    QCheckBox* useCalcCharset;
    QCheckBox* lazyLoading;
    QCheckBox* autoBlocks;
    QCheckBox* removeTrailingSpaces;
    QWidget* TabPage_2;
    QLabel* settingsForLabel;
    KComboBox* syntaxLanguage;
    QCheckBox* syntaxEnabled;
    KPushButton* resetButton;
    KPushButton* parenthesisStyleButton;
    KPushButton* parenthesisColorsButton;
    KPushButton* symbolStyleButton;
    KPushButton* numberStyleButton;
    KPushButton* symbolColorButton;
    KPushButton* numberColorButton;
    KListView* syntaxListView;
    KPushButton* newStyleButton;
    KPushButton* newListButton;
    KPushButton* editButton;
    QWidget* TabPage_3;
    QGroupBox* templateGroupBox;
    KListBox* templateListBox;
    KTextEdit* templateCode;
    KLineEdit* templateIdentifier;
    QLabel* codeLabel;
    QLabel* identifierLabel;
    KPushButton* clearSelectionButton;
    KPushButton* applyButton;
    QGroupBox* completionGroupBox;
    KPushButton* regenCompletionInfoButton;
    KPushButton* okButton;
    KPushButton* cancelButton;

public slots:
    virtual void init();
    virtual void destroy();
    virtual void linkTarget_toggled( bool unused_on );
    virtual void bgColorChange_clicked();
    virtual void editorFontChange_clicked();
    virtual void syntaxLanguage_activated( int index );
    virtual void syntaxEnabled_toggled( bool on );
    virtual void resetButton_clicked();
    virtual void numberColorButton_clicked();
    virtual void numberStyleButton_clicked();
    virtual void symbolColorButton_clicked();
    virtual void symbolStyleButton_clicked();
    virtual void parenthesisColorsButton_clicked();
    virtual void parenthesisStyleButton_clicked();
    virtual void syntaxListView_selectionChanged();
    virtual void syntaxListView_itemRenamed( QListViewItem * item, const QString & str, int unused_col );
    virtual void syntaxListViewAccel_activated( int id );
    virtual void newStyleButton_clicked();
    virtual void newListButton_clicked();
    virtual void editButton_clicked();
    virtual void editDialog_colorButton_clicked();
    virtual void editDialog_styleButton_clicked();
    virtual void clearSelectionButton_clicked();
    virtual void applyButton_clicked();
    virtual void templateListBox_selectionChanged();
    virtual void templateListBox_currentChanged( QListBoxItem * item );
    virtual void templateIdentifier_textChanged( const QString & text );
    virtual void regenCompletionInfoButton_clicked();

protected:
    QVBoxLayout* PreferencesLayout;
    QVBoxLayout* Widget8Layout;
    QSpacerItem* spacer10;
    QVBoxLayout* Widget9Layout;
    QVBoxLayout* linkTargetLayout;
    QSpacerItem* spacer12;
    QHBoxLayout* layout40;
    QSpacerItem* spacer59;
    QVBoxLayout* linkPortLayout;
    QVBoxLayout* linkCableLayout;
    QVBoxLayout* TabPageLayout;
    QSpacerItem* spacer14;
    QHBoxLayout* layout35;
    QSpacerItem* spacer55;
    QSpacerItem* spacer56;
    QHBoxLayout* layout7;
    QHBoxLayout* layout36;
    QSpacerItem* spacer57;
    QHBoxLayout* layout38;
    QHBoxLayout* layout37;
    QSpacerItem* spacer58;
    QVBoxLayout* TabPageLayout_2;
    QHBoxLayout* layout8;
    QGridLayout* layout9;
    QHBoxLayout* layout19;
    QVBoxLayout* layout18;
    QSpacerItem* spacer15;
    QVBoxLayout* TabPageLayout_3;
    QVBoxLayout* templateGroupBoxLayout;
    QGridLayout* layout16;
    QHBoxLayout* layout17;
    QSpacerItem* spacer8;
    QVBoxLayout* completionGroupBoxLayout;
    QHBoxLayout* layout18_2;
    QSpacerItem* spacer28;

protected slots:
    virtual void languageChange();

};

#endif // PREFERENCES_H
