/****************************************************************************
** Form implementation generated from reading ui file 'toolprops.ui'
**
** Created by User Interface Compiler
**
** WARNING! All changes made in this file will be lost!
****************************************************************************/

#include "toolprops.h"

#include <qvariant.h>
#include <qlabel.h>
#include <kurlrequester.h>
#include <klineedit.h>
#include <qcheckbox.h>
#include <kpushbutton.h>
#include <qlayout.h>
#include <qtooltip.h>
#include <qwhatsthis.h>
#include <qimage.h>
#include <qpixmap.h>

#include "kurlrequester.h"
#include "klineedit.h"
#include "kpushbutton.h"
#include "../toolprops.ui.h"
/*
 *  Constructs a ToolProperties as a child of 'parent', with the
 *  name 'name' and widget flags set to 'f'.
 *
 *  The dialog will by default be modeless, unless you set 'modal' to
 *  TRUE to construct a modal dialog.
 */
ToolProperties::ToolProperties( QWidget* parent, const char* name, bool modal, WFlags fl )
    : QDialog( parent, name, modal, fl )
{
    if ( !name )
	setName( "ToolProperties" );
    ToolPropertiesLayout = new QVBoxLayout( this, 11, 6, "ToolPropertiesLayout"); 

    layout24 = new QGridLayout( 0, 1, 1, 0, 6, "layout24"); 

    commandLineLabel = new QLabel( this, "commandLineLabel" );
    commandLineLabel->setAlignment( int( QLabel::AlignVCenter | QLabel::AlignRight ) );

    layout24->addWidget( commandLineLabel, 1, 0 );

    workingDirectoryLabel = new QLabel( this, "workingDirectoryLabel" );
    workingDirectoryLabel->setAlignment( int( QLabel::AlignVCenter | QLabel::AlignRight ) );

    layout24->addMultiCellWidget( workingDirectoryLabel, 2, 3, 0, 0 );

    workingDirectory = new KURLRequester( this, "workingDirectory" );
    workingDirectory->setMode( 26 );

    layout24->addMultiCellWidget( workingDirectory, 3, 3, 1, 2 );

    commandLine = new KLineEdit( this, "commandLine" );

    layout24->addMultiCellWidget( commandLine, 1, 2, 1, 1 );

    runInTerminal = new QCheckBox( this, "runInTerminal" );

    layout24->addMultiCellWidget( runInTerminal, 4, 4, 0, 2 );

    toolTitle = new KLineEdit( this, "toolTitle" );

    layout24->addMultiCellWidget( toolTitle, 0, 0, 1, 2 );

    browseButton = new KPushButton( this, "browseButton" );

    layout24->addMultiCellWidget( browseButton, 1, 2, 2, 2 );

    toolTitleLabel = new QLabel( this, "toolTitleLabel" );
    toolTitleLabel->setAlignment( int( QLabel::AlignVCenter | QLabel::AlignRight ) );

    layout24->addWidget( toolTitleLabel, 0, 0 );
    ToolPropertiesLayout->addLayout( layout24 );
    spacer18 = new QSpacerItem( 20, 21, QSizePolicy::Minimum, QSizePolicy::Expanding );
    ToolPropertiesLayout->addItem( spacer18 );

    layout2 = new QHBoxLayout( 0, 0, 6, "layout2"); 
    spacer2 = new QSpacerItem( 321, 20, QSizePolicy::Expanding, QSizePolicy::Minimum );
    layout2->addItem( spacer2 );

    okButton = new KPushButton( this, "okButton" );
    okButton->setEnabled( FALSE );
    okButton->setProperty( "stdItem", 1 );
    layout2->addWidget( okButton );

    cancelButton = new KPushButton( this, "cancelButton" );
    cancelButton->setProperty( "stdItem", 2 );
    layout2->addWidget( cancelButton );
    ToolPropertiesLayout->addLayout( layout2 );
    languageChange();
    resize( QSize(600, 184).expandedTo(minimumSizeHint()) );
    clearWState( WState_Polished );

    // signals and slots connections
    connect( okButton, SIGNAL( clicked() ), this, SLOT( accept() ) );
    connect( cancelButton, SIGNAL( clicked() ), this, SLOT( reject() ) );
    connect( toolTitle, SIGNAL( textChanged(const QString&) ), this, SLOT( validate() ) );
    connect( commandLine, SIGNAL( textChanged(const QString&) ), this, SLOT( validate() ) );
    connect( workingDirectory, SIGNAL( textChanged(const QString&) ), this, SLOT( validate() ) );
    connect( browseButton, SIGNAL( clicked() ), this, SLOT( browseButton_clicked() ) );

    // tab order
    setTabOrder( toolTitle, commandLine );
    setTabOrder( commandLine, workingDirectory );
    setTabOrder( workingDirectory, runInTerminal );
    setTabOrder( runInTerminal, browseButton );
    setTabOrder( browseButton, okButton );
    setTabOrder( okButton, cancelButton );

    // buddies
    commandLineLabel->setBuddy( commandLine );
    workingDirectoryLabel->setBuddy( workingDirectory );
    toolTitleLabel->setBuddy( toolTitle );
    init();
}

/*
 *  Destroys the object and frees any allocated resources
 */
ToolProperties::~ToolProperties()
{
    // no need to delete child widgets, Qt does it all for us
}

/*
 *  Sets the strings of the subwidgets using the current
 *  language.
 */
void ToolProperties::languageChange()
{
    setCaption( tr( "Tool Properties" ) );
    commandLineLabel->setText( tr( "Command &Line:" ) );
    workingDirectoryLabel->setText( tr( "&Working Directory:" ) );
    runInTerminal->setText( tr( "&Run in Terminal" ) );
    runInTerminal->setAccel( QKeySequence( tr( "Alt+R" ) ) );
    browseButton->setText( tr( "&Browse..." ) );
    browseButton->setAccel( QKeySequence( tr( "Alt+B" ) ) );
    toolTitleLabel->setText( tr( "&Title:" ) );
    okButton->setText( tr( "&OK" ) );
    okButton->setAccel( QKeySequence( tr( "Alt+O" ) ) );
    cancelButton->setText( tr( "&Cancel" ) );
    cancelButton->setAccel( QKeySequence( tr( "Alt+C" ) ) );
}

