/****************************************************************************
** Form implementation generated from reading ui file 'toolsdlg.ui'
**
** Created by User Interface Compiler
**
** WARNING! All changes made in this file will be lost!
****************************************************************************/

#include "toolsdlg.h"

#include <qvariant.h>
#include <qheader.h>
#include <klistview.h>
#include <kpushbutton.h>
#include <qlayout.h>
#include <qtooltip.h>
#include <qwhatsthis.h>
#include <qimage.h>
#include <qpixmap.h>

#include "klistview.h"
#include "kpushbutton.h"
#include "../toolsdlg.ui.h"
/*
 *  Constructs a ToolsDialog as a child of 'parent', with the
 *  name 'name' and widget flags set to 'f'.
 *
 *  The dialog will by default be modeless, unless you set 'modal' to
 *  TRUE to construct a modal dialog.
 */
ToolsDialog::ToolsDialog( QWidget* parent, const char* name, bool modal, WFlags fl )
    : QDialog( parent, name, modal, fl )
{
    if ( !name )
	setName( "ToolsDialog" );
    ToolsDialogLayout = new QHBoxLayout( this, 11, 6, "ToolsDialogLayout"); 

    listView = new KListView( this, "listView" );
    listView->addColumn( tr( "Title" ) );
    listView->header()->setClickEnabled( FALSE, listView->header()->count() - 1 );
    listView->addColumn( tr( "Command Line" ) );
    listView->header()->setClickEnabled( FALSE, listView->header()->count() - 1 );
    listView->addColumn( tr( "Working Directory" ) );
    listView->header()->setClickEnabled( FALSE, listView->header()->count() - 1 );
    listView->addColumn( tr( "Terminal" ) );
    listView->header()->setClickEnabled( FALSE, listView->header()->count() - 1 );
    listView->setAllColumnsShowFocus( TRUE );
    listView->setItemsMovable( FALSE );
    ToolsDialogLayout->addWidget( listView );

    layout1 = new QVBoxLayout( 0, 0, 6, "layout1"); 

    addButton = new KPushButton( this, "addButton" );
    layout1->addWidget( addButton );

    editButton = new KPushButton( this, "editButton" );
    editButton->setEnabled( FALSE );
    layout1->addWidget( editButton );

    removeButton = new KPushButton( this, "removeButton" );
    removeButton->setEnabled( FALSE );
    layout1->addWidget( removeButton );
    spacer1 = new QSpacerItem( 20, 211, QSizePolicy::Minimum, QSizePolicy::Expanding );
    layout1->addItem( spacer1 );

    okButton = new KPushButton( this, "okButton" );
    okButton->setProperty( "stdItem", 1 );
    layout1->addWidget( okButton );

    cancelButton = new KPushButton( this, "cancelButton" );
    cancelButton->setProperty( "stdItem", 2 );
    layout1->addWidget( cancelButton );
    ToolsDialogLayout->addLayout( layout1 );
    languageChange();
    resize( QSize(598, 266).expandedTo(minimumSizeHint()) );
    clearWState( WState_Polished );

    // signals and slots connections
    connect( okButton, SIGNAL( clicked() ), this, SLOT( accept() ) );
    connect( cancelButton, SIGNAL( clicked() ), this, SLOT( reject() ) );
    connect( addButton, SIGNAL( clicked() ), this, SLOT( addButton_clicked() ) );
    connect( editButton, SIGNAL( clicked() ), this, SLOT( editButton_clicked() ) );
    connect( removeButton, SIGNAL( clicked() ), this, SLOT( removeButton_clicked() ) );
    connect( listView, SIGNAL( selectionChanged() ), this, SLOT( listView_selectionChanged() ) );
    init();
}

/*
 *  Destroys the object and frees any allocated resources
 */
ToolsDialog::~ToolsDialog()
{
    // no need to delete child widgets, Qt does it all for us
}

/*
 *  Sets the strings of the subwidgets using the current
 *  language.
 */
void ToolsDialog::languageChange()
{
    setCaption( tr( "Configure Tools" ) );
    listView->header()->setLabel( 0, tr( "Title" ) );
    listView->header()->setLabel( 1, tr( "Command Line" ) );
    listView->header()->setLabel( 2, tr( "Working Directory" ) );
    listView->header()->setLabel( 3, tr( "Terminal" ) );
    addButton->setText( tr( "&Add..." ) );
    addButton->setAccel( QKeySequence( tr( "Alt+A" ) ) );
    editButton->setText( tr( "&Edit..." ) );
    editButton->setAccel( QKeySequence( tr( "Alt+E" ) ) );
    removeButton->setText( tr( "&Remove" ) );
    removeButton->setAccel( QKeySequence( tr( "Alt+R" ) ) );
    okButton->setText( tr( "&OK" ) );
    okButton->setAccel( QKeySequence( tr( "Alt+O" ) ) );
    cancelButton->setText( tr( "&Cancel" ) );
    cancelButton->setAccel( QKeySequence( tr( "Alt+C" ) ) );
}

